// 002 u_c_cgi_forms
// 27 apr 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

// -- jan 2005: ??
// --  seems to write all to a variable length file
// --  then reads some fields back

// -- SHOULD descend from c_cge_base_forms

(*$r+*)

unit u_c_cgi_forms;
  interface

    // const k_form_file_name= 'form';

    type t_string_position= record
                              m_offset, m_length: Integer;
                            end;
         t_form= record
                   m_id: Integer;
                   m_length: Integer;

                   // -- the page which was called, the url clicked
                   // --   (set by SiteEditor)
                   m_page, m_url: Integer;
                   // -- the date of the cgi call
                   m_date: Double;

                   m_content_length: Integer;

                   // m_url,
                   // -- HTTP or FTP
                   m_server_port, m_server_protocol,
                     // -- GET, POST, PUT
                     m_request_method,
                     // -- the file requested ("filename=u_c_log.zip")
                     m_query_string,
                     // -- "plus_facile.com"
                     m_remote_host,
                     // -- "192.0.0.3"
                     m_remote_address,
                     // -- the answer: "tres_bien=3&sem_comment=a%36&"
                     m_answer_string,

                     fill1, fill2, fill3: t_string_position;
                 end;

         c_form= class
                   public
                     m_form_creation_ok: Boolean;

                     m_name: String;
                     m_count: Integer;

                     m_form_file_name: String;
                     m_forms: file of t_form;
                     m_form: t_form;

                     // m_is_open: Boolean;
                     m_strings_file_name: String;
                     m_strings_file: File;

                     m_request_method: String;
                     m_remote_address_string: String;
                     m_raw_answer_string, m_the_answer_string: String;

                     m_the_query_string: String;

                     Constructor create_form(p_name, p_form_file_name: String); Virtual;

                     procedure create_files;

                     procedure write_string(p_id: Integer; p_string: ShortString;
                         var pv_string_position: t_string_position);
                     function f_read_string(p_string_position: t_string_position): String;

                     procedure write_long_string(p_id: Integer; p_string: String;
                         var pv_string_position: t_string_position);
                     function f_read_long_string(p_string_position: t_string_position): String;

                     procedure open_files;
                     procedure close_files;

                       procedure read_answer;
                     procedure get_form_result;

                     function f_display_form(p_domain: String): String;

                     Destructor Destroy; Override;
                 end;

  implementation
    uses SysUtils, Windows
        , u_cgi_dir
        , u_c_cgi_log
        , u_cgi_helpers // -- convert special characters
        ;

    const k_return= Chr(13);
          k_line_feed= Chr(10);

    // -- c_form

    Constructor c_form.create_form(p_name, p_form_file_name: String);
      begin
        Inherited ;
        m_name:= p_name;
        write_log('form_file_name '+ p_form_file_name+ '.bin');

        // -- the base name
        m_form_file_name:= p_form_file_name+ 'bin.dat';

        // -- the bin
        Assign(m_forms, m_form_file_name);

        // -- the str
        m_strings_file_name:= p_form_file_name+ 'str.dat';
        Assign(m_strings_file, m_strings_file_name);

        // -- not necessary
        m_form_creation_ok:= true;
      end; // create_form

    procedure c_form.write_string(p_id: Integer; p_string: ShortString;
        var pv_string_position: t_string_position);
      begin
        with pv_string_position do
        begin
          m_length:= Length(p_string);
          if m_length> 0
            then begin
                m_offset:= FilePos(m_strings_file);

                BlockWrite(m_strings_file, p_id, 4);
                BlockWrite(m_strings_file, m_length, 1);
                BlockWrite(m_strings_file, p_string[1], m_length);
              end
            else FillChar(pv_string_position, SizeOf(t_string_position), 0);
        end;
      end; // write_string

    function c_form.f_read_string(p_string_position: t_string_position): String;
      var l_id: Integer;
          l_length: Byte;
      begin
        with p_string_position do
          if m_offset<> 0
            then begin
                Seek(m_strings_file, m_offset);
                // -- skip id
                BlockRead(m_strings_file, l_id, 4);
                BlockRead(m_strings_file, l_length, 1);
                SetLength(Result, m_length);
                BlockRead(m_strings_file, Result[1], m_length);
              end
            else Result:= '';
      end; // f_read_string

    // -- "long" String

    procedure c_form.write_long_string(p_id: Integer; p_string: String;
        var pv_string_position: t_string_position);
      begin
        with pv_string_position do
        begin
          m_length:= Length(p_string);
          if m_length> 0
            then begin
                m_offset:= FilePos(m_strings_file);

                BlockWrite(m_strings_file, p_id, 4);
                BlockWrite(m_strings_file, m_length, 4);
                BlockWrite(m_strings_file, p_string[1], m_length);
              end
            else FillChar(pv_string_position, SizeOf(t_string_position), 0);
        end;
      end; // write_long_string

    function c_form.f_read_long_string(p_string_position: t_string_position): String;
      var l_id: Integer;
          l_length: Integer;
      begin
        with p_string_position do
          if m_offset<> 0
            then begin
                Seek(m_strings_file, m_offset);
                // -- skip id
                BlockRead(m_strings_file, l_id, 4);
                BlockRead(m_strings_file, l_length, 4);
                SetLength(Result, m_length);
                BlockRead(m_strings_file, Result[1], m_length);
              end
            else Result:= '';
      end; // f_read_long_string

    // -- file creation, opening, closing

    procedure c_form.create_files;
      var l_form_file_path: String;
      begin
        write_log('create_form_files');

        l_form_file_path:= ExtractFilePath(m_form_file_name);

        if f_directory_exists(l_form_file_path)
          then begin
              // -- create the file
              write_log('create_path '+ l_form_file_path);
              f_force_directories(l_form_file_path);
            end;

        Rewrite(m_forms);

        Rewrite(m_strings_file, 1);
        FillChar(m_form, SizeOf(m_form), 0);

        write_string(1, 'not_found', m_form.m_server_port);

        Write(m_forms, m_form);
        // Close(m_forms);
      end; // create_files

    procedure c_form.open_files;
      begin
        Reset(m_forms);
        Reset(m_strings_file, 1);
      end; // open_files

    procedure c_form.close_files;
      begin
        Close(m_forms);
        Close(m_strings_file);
      end; // close_files

    // -- form-specific

    procedure c_form.read_answer;
        // -- read back this field from the INPUT
      var l_index: Integer;
      begin
        if (UpperCase(m_request_method)= 'POST') and (m_form.m_content_length> 0)
          then
            begin
              // -- +1 for last & added by us
              SetLength(m_raw_answer_string, m_form.m_content_length+ 1);

              // -- read StdIn
              for l_index:= 1 to m_form.m_content_length do
                Read(m_raw_answer_string[l_index]);

              // -- add last &
              m_raw_answer_string[m_form.m_content_length+ 1]:= '&';

              // -- now remove special characters "+" "$xx" "&" etc
              m_the_answer_string:= f_convert_special_characters(m_raw_answer_string);
            end // post and content-length
          else m_the_answer_string:= '*** no_post or 0 length';
      end; // read_answer

    procedure c_form.get_form_result;
        // -- get some values from the environment
        // -- write some to the file

      function f_get_environment_value(p_key: pChar): String;
        const k_max= 255;
        var l_environment_value: String[k_max];
            l_size: Integer;
        begin
          l_size:= GetEnvironmentVariable(p_key, @ l_environment_value[1], k_max);
          l_environment_value[0]:= chr(l_size);
          Result:= l_environment_value;
        end; // f_get_environment_value

      var l_previous_environment_value: String;

      procedure do_write(p_key: pChar; var pv_member: t_string_position);
        var l_environment_value: String;
        begin
          l_environment_value:= f_get_environment_value(p_key);

          if l_environment_value<> l_previous_environment_value
            then begin
                write_string(m_form.m_id, l_environment_value, pv_member);
                Inc(m_form.m_length, Length(l_environment_value));

                if p_key= 'REQUEST_METHOD'
                  then m_request_method:= l_environment_value
                  else
                    if p_key= 'REMOTE_ADDR'
                      then m_remote_address_string:= l_environment_value;
              end;

          l_previous_environment_value:= l_environment_value;
        end; // do_write

      procedure read_content_length;
        var l_content: String;
        begin
          l_content:= f_get_environment_value('CONTENT_LENGTH');
          If Length(l_content)> 0
            then m_form.m_content_length:= StrToInt(l_content);
        end; // read_content_length

      begin // get_form_result
        FillChar(m_form, SizeOf(m_form), 0);

        if FileExists(m_form_file_name)
          then begin
              Reset(m_forms);
              Seek(m_forms, FileSize(m_forms));

              Reset(m_strings_file, 1);
              Seek(m_strings_file, FileSize(m_strings_file));
            end
          else create_files;

        m_count:= FileSize(m_forms);

        with m_form do
        begin
          m_id:= m_count;
          m_date:= Now;

          l_previous_environment_value:= '';
          do_write('SERVER_PORT', m_server_port);
          do_write('SERVER_PROTOCOL', m_server_protocol);
          // -- GET, POST, PUT
          do_write('REQUEST_METHOD', m_request_method);
          // -- the file requested ("filename=u_c_log.zip")
          do_write('QUERY_STRING', m_query_string);
          // -- "192.0.0.3"
          do_write('REMOTE_ADDR', m_remote_address);
          // -- "plus_facile.com"
          do_write('REMOTE_HOST', m_remote_host);

          read_content_length;

          read_answer;

          write_long_string(m_form.m_id, m_the_answer_string, m_answer_string);
          Inc(m_form.m_length, Length(m_the_answer_string));
        end; // with m_form

        Write(m_forms, m_form);
        close_files;

        m_the_query_string:= f_get_environment_value('QUERY_STRING');
      end; // get_form_result

    function c_form.f_display_form(p_domain: String): String;
      const k_new_line= chr(13)+ Chr(10);

      function f_non_empty_string(p_key: t_string_position; p_title: String): String;
        begin
          Result:= f_read_string(p_key);
          if Result<> ''
            then Result:= k_new_line+ '                 '+ p_title+ ': '+ Result;
        end; // f_non_empty_string

      function f_non_empty_long_string(p_key: t_string_position; p_title: String): String;
        begin
          Result:= f_read_long_string(p_key);

          if Result<> ''
            then Result:= k_new_line+ '                 '+ p_title+ ': '
                + f_convert_special_characters(Result);
        end; // f_non_empty_long_string

      function f_remote(p_remote: String): String;
        begin
          Result:= k_new_line+ '                 Rem_ad: '+ p_remote+ ' '+ p_domain;
        end; // f_remote

      function f_format_answer(p_answer: String): String;
         // -- AAA=aaa&BBB=bbb&...

        function f_extract_string(p_start, p_end: Integer): String;
          var l_length: Integer;
              l_index: Integer;
          begin
            l_length:= p_end+ 1- p_start;
            if l_length> 0
              then begin
                  SetLength(Result, l_length);
                  Move(p_answer[p_start], Result[1], l_length);

                  // -- remove RET, LF
                  for l_index:= 1 to l_length do
                    if (Result[l_index]= k_return)
                        or (Result[l_index]= k_line_feed)
                      then Result[l_index]:= ' ';
                end
              else Result:= '';
          end; // f_extract_string

        var l_index, l_length, l_start_index: Integer;
            l_title, l_answer: String;

        begin // f_format_answer
          l_index:= 1; l_length:= Length(p_answer);
          // display(' >'+ p_answer+ '<');

          while l_index<= l_length do
          begin
            l_start_index:= l_index;
            while (l_index<= l_length) and (p_answer[l_index]<> '=') do
              Inc(l_index);
            l_title:= f_extract_string(l_start_index, l_index- 1);

            // -- skip =
            Inc(l_index);

            l_start_index:= l_index;
            while (l_index<= l_length) and (p_answer[l_index]<> '&') do
              Inc(l_index);
            l_answer:= f_extract_string(l_start_index, l_index- 1);

            if l_answer<> ''
              then begin
                  Result:= Result+ k_new_line+ Format('%-12s ', [l_title])+ l_answer;
                end;

            // -- skip &
            Inc(l_index);
          end; // while l_index<= l_length
        end; // f_format_answer

      begin // f_display_form
        with m_form do
          Result:= Format('%4d %2d %3d %4d ', [m_id, m_length, m_page, m_content_length])
            + FormatDateTime('yyyy/mm/dd hh:nn:ss:zzz ', m_date)
            + f_non_empty_string(m_server_port,     'Port  ')
            + f_non_empty_string(m_server_protocol, 'Proto ')
            + f_non_empty_string(m_query_string,    'Query ')
            + f_non_empty_string(m_request_method,  'Method')
            + f_non_empty_string(m_remote_host,     'Remote')
            // + f_non_empty_string(m_remote_address,  'Rem_ad')
            + f_remote(f_read_string(m_remote_address))
            + f_format_answer(f_read_long_string(m_answer_string))
            ;
      end; // f_display_form

    Destructor c_form.Destroy;
      begin
        Inherited;
      end; // Destroy

    begin // u_c_form
    end. // u_c_form
