// 002 u_cgi_training_information_test
// 19 may 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_cgi_training_information_test;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    exit_: TButton;
    clear_: TButton;
    send_: TButton;
    load_log_: TButton;
    oo: TCheckBox;
    database: TCheckBox;
    uml_dp: TCheckBox;
    e_mail: TEdit;
    load_html_: TButton;
    check_extraction_: TButton;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure send_Click(Sender: TObject);
    procedure load_log_Click(Sender: TObject);
    procedure load_html_Click(Sender: TObject);
    procedure check_extraction_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

    implementation
      uses u_cgi_helpers
          , u_cgi_training_handler
        ;


{$R *.dfm}

    const k_datas_segment= 'log\';
          k_training_write_segment= 'training_info\';
          k_training_log_name= 'log_training_information.txt';

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        Memo1.Lines.Clear;
      end; // clear_Click

    // -- test the complete chain

    procedure build_debug_request;
      begin
        with Form1 do
        begin
          // -- |oo=on&e_mail=aha|
          g_debug_request:= '';

          if database.Checked
            then g_debug_request:= g_debug_request+ 'database=on&';
          if oo.Checked
            then g_debug_request:= g_debug_request+ 'oo=on&';
          if uml_dp.Checked
            then g_debug_request:= g_debug_request+ 'uml_dp=on&';
          if e_mail.Text<> ''
            then g_debug_request:= g_debug_request+ 'e_mail='+ e_mail.Text;

          Memo1.Lines.Add('');
          Memo1.Lines.Add(g_debug_request);
        end; // with Form1
      end; // build_debug_request

    procedure TForm1.send_Click(Sender: TObject);
      begin
        g_output_name:= 'result.txt';
        build_debug_request;

        do_handle_cgi(k_datas_segment+ k_training_write_segment,
            k_training_log_name, '');
      end; // send_Click

    procedure TForm1.load_log_Click(Sender: TObject);
      begin
        Memo1.Lines.LoadFromFile(k_datas_segment+ k_training_write_segment+ k_training_log_name);
      end; // load_log_Click

    procedure TForm1.load_html_Click(Sender: TObject);
      begin
        Memo1.Lines.LoadFromFile(ExtractFilePath(Application.ExeName)+ '\Result.html');
      end; // load_html_Click

    procedure TForm1.check_extraction_Click(Sender: TObject);
      var l_c_key_value_list: tStringList;
      begin
        l_c_key_value_list:= tStringList.Create;

        build_debug_request;

        extract_key_values(g_debug_request+ '&', l_c_key_value_list);

        Memo1.Lines.Add(l_c_key_value_list.Text);
        Memo1.Lines.Add('====');
        Memo1.Lines.Add('1='+ l_c_key_value_list.Values['database']);
        Memo1.Lines.Add('2='+ l_c_key_value_list.Values['oo']);
        Memo1.Lines.Add('3='+ l_c_key_value_list.Values['uml_dp']);
        Memo1.Lines.Add('4='+ l_c_key_value_list.Values['e_mail']);
        Memo1.Lines.Add('====');
        Memo1.Lines.Add(IntToStr(l_c_key_value_list.Count));
      end; // check_extraction_Click

end.
